unit inifile;
interface
uses strs;

const longset:set of char=[' ','0'..'9','+','-'];
      realset:set of char=[' ','0'..'9','.','+','-','e','E'];
      boolstr:array[false..true] of string[5]=('FALSE','TRUE');

type piniitem=^tiniitem;
     tiniitem=record
     itemname:pointer;
     nextitem:piniitem;
     case kind:byte of
          0:(sdata:pointer);
          1:(ldata:longint);
          2:(rdata:real);
          3:(bdata:boolean);
     end;

     pinisection=^tinisection;
     tinisection=record
     sectionname:pointer;
     nextsection:pinisection;
     firstitem:piniitem;
     end;

     pinihead=^tinihead;
     tinihead=record
     f:text;
     firstsection:pinisection;
     readonly:boolean;
     end;

function iniopen(ininame:string):pinihead;
procedure iniclose(inihand:pinihead);
procedure setreadonly(inihand:pinihead;ro:boolean);

function iniitemtype(inihand:pinihead;section:string;item:string):byte;

function inireadstring(inihand:pinihead;section:string;item:string;default:string):string;
function inireadlong(inihand:pinihead;section:string;item:string;default:longint):longint;
function inireadreal(inihand:pinihead;section:string;item:string;default:real):real;
function inireadbool(inihand:pinihead;section:string;item:string;default:boolean):boolean;

procedure iniwritestring(inihand:pinihead;section:string;item:string;data:string);
procedure iniwritelong(inihand:pinihead;section:string;item:string;data:longint);
procedure iniwritereal(inihand:pinihead;section:string;item:string;data:real);
procedure iniwritebool(inihand:pinihead;section:string;item:string;data:boolean);

procedure inidelsection(inihand:pinihead;section:string);
procedure inidelitem(inihand:pinihead;section:string;item:string);

function inifirstsection(inihand:pinihead):pinisection;
function ininextsection(inisection:pinisection):pinisection;
function inisectionname(inisection:pinisection):string;
function inisectionptr(inihand:pinihead;section:string):pinisection;

function inifirstitem(inisection:pinisection):piniitem;
function ininextitem(iniitem:piniitem):piniitem;
function iniitemname(iniitem:piniitem):string;
function iniitemdata(iniitem:piniitem):string;

function iniitemptrtype(iniitem:piniitem):byte;

implementation

function checktype(s:string):byte;
var i:byte;
begin
s:=uppercase(s); if s='' then begin checktype:=0;{string} exit; end;
if (s='YES') or (s='TRUE') or (s='ON') or
   (s='NO') or (s='FALSE') or (s='OFF') then begin checktype:=3;{boolean} exit; end;
checktype:=1;{longint}
for i:=1 to byte(s[0]) do
    begin
    if not (s[i] in realset) then begin checktype:=0;{string} exit; end;
    if not (s[i] in longset) then begin checktype:=2;{real} end;
    end;
end;


function stringtopchar(s:string):pointer;
var p:pointer;
begin
getmem(p,length(s)+1);
move(s[0],p^,length(s)+1);
stringtopchar:=p;
end;

function pchartostring(p:pointer):string;
begin
pchartostring:=string(p^);
end;

procedure killpchar(var p:pointer);
begin
if p=nil then exit;
freemem(p,byte(p^)+1);
p:=nil;
end;


function iniopen(ininame:string):pinihead;
var inihead:pinihead;
    cursection,cs:pinisection;
    curitem,ci:piniitem;
    s:string;
begin
new(inihead);
with inihead^ do
     begin
     readonly:=false;
     firstsection:=nil;
     assign(f,ininame);
     {$i-} reset(f); {$i+}
     if ioresult<>0 then rewrite(f) else
     while not seekeof(f) do
           begin
           if seekeoln(f) then begin readln(f,s); continue; end;
           readln(f,s); s:=uppercase(s);
           if (firstsection=nil) and ((pos('[',s)=0) or (pos(']',s)=0)) then runerror(50);
           if (pos('[',s)<>0) and (pos(']',s)>pos('[',s)) then
              begin
              s:=copy(s,pos('[',s)+1,pos(']',s)-pos('[',s)-1);
              new(cs);
              if firstsection=nil then firstsection:=cs else cursection^.nextsection:=cs;
              cursection:=cs;
              cursection^.sectionname:=stringtopchar(s);
              cursection^.firstitem:=nil;
              cursection^.nextsection:=nil;
              end else
              with cursection^ do
                   begin
                   if (pos('=',s)=0) then runerror(50);
                   new(ci);
                   if firstitem=nil then firstitem:=ci else curitem^.nextitem:=ci;
                   curitem:=ci;
                   with curitem^ do
                        begin
                        itemname:=stringtopchar(copy(s,1,pos('=',s)-1));
                        nextitem:=nil;
                        s:=copy(s,pos('=',s)+1,255);
                        while (s<>'') and (s[length(s)]=' ') do delete(s,length(s),1);
                        kind:=checktype(s);
                        case kind of
                             0:sdata:=stringtopchar(s);
                             1:str2long(s,ldata);
                             2:str2real(s,rdata);
                             3:if (s='TRUE') or (s='YES') or (s='ON') then bdata:=true
                                  else bdata:=false;
                             end; {case}
                        end;
                   end;
           end;
     close(f);
     end;
iniopen:=inihead;
end;

procedure iniclose(inihand:pinihead);
var cursection,cs:pinisection;
    curitem,ci:piniitem;
begin
with inihand^ do
     begin
     if not readonly then
        begin
        rewrite(f);
        cursection:=firstsection;
        while cursection<>nil do
              with cursection^ do
                   begin
                   writeln(f,'[',pchartostring(sectionname),']');
                   curitem:=firstitem;
                   while curitem<>nil do
                         with curitem^ do
                              begin
                              write(f,pchartostring(itemname),'=');
                              case kind of
                                   0:writeln(f,pchartostring(sdata));
                                   1:writeln(f,long2str(ldata,0));
                                   2:writeln(f,realtostr(rdata));
                                   3:writeln(f,bdata);
                                   end; {case}
                              curitem:=nextitem;
                              end;
                   writeln(f);
                   cursection:=nextsection;
                   end;
        close(f);
        end;
        cursection:=firstsection;
        while cursection<>nil do
              with cursection^ do
                   begin
                   curitem:=firstitem;
                   while curitem<>nil do
                         with curitem^ do
                              begin
                              ci:=curitem;
                              if kind=0 then killpchar(sdata);
                              killpchar(itemname);
                              curitem:=nextitem;
                              dispose(ci);
                              end;
                   cs:=cursection;
                   killpchar(sectionname);
                   cursection:=nextsection;
                   dispose(cs);
                   end;
     dispose(inihand);
     end;
end;

procedure setreadonly(inihand:pinihead;ro:boolean);
begin
inihand^.readonly:=ro;
end;

function iniitemtype(inihand:pinihead;section:string;item:string):byte;
var cursection:pinisection;
    curitem:piniitem;
begin
section:=uppercase(section); item:=uppercase(item);
iniitemtype:=255;
cursection:=inihand^.firstsection;
while cursection<>nil do
      with cursection^ do
           begin
           if pchartostring(sectionname)=section then
              begin
              curitem:=firstitem;
              while curitem<>nil do
                    with curitem^ do
                         begin
                         if pchartostring(itemname)=item then
                            begin
                            iniitemtype:=kind;
                            end;
                         curitem:=nextitem;
                         end;
              end;
           cursection:=nextsection;
           end;
end;

function inireadstring(inihand:pinihead;section:string;item:string;default:string):string;
var find:boolean;
    cursection:pinisection;
    curitem:piniitem;
begin
section:=uppercase(section); item:=uppercase(item); default:=uppercase(default);
inireadstring:=default;
find:=false;
cursection:=inihand^.firstsection;
while cursection<>nil do
      with cursection^ do
           begin
           if pchartostring(sectionname)=section then
              begin
              curitem:=firstitem;
              while curitem<>nil do
                    with curitem^ do
                         begin
                         if pchartostring(itemname)=item then
                            begin
                            find:=true;
                            inireadstring:=pchartostring(sdata);
                            end;
                         curitem:=nextitem;
                         end;
              end;
           cursection:=nextsection;
           end;
if not find then iniwritestring(inihand,section,item,default);
end;

function inireadlong(inihand:pinihead;section:string;item:string;default:longint):longint;
var find:boolean;
    cursection:pinisection;
    curitem:piniitem;
begin
section:=uppercase(section); item:=uppercase(item);
inireadlong:=default;
find:=false;
cursection:=inihand^.firstsection;
while cursection<>nil do
      with cursection^ do
           begin
           if pchartostring(sectionname)=section then
              begin
              curitem:=firstitem;
              while curitem<>nil do
                    with curitem^ do
                         begin
                         if pchartostring(itemname)=item then
                            begin
                            find:=true;
                            inireadlong:=ldata;
                            end;
                         curitem:=nextitem;
                         end;
              end;
           cursection:=nextsection;
           end;
if not find then iniwritelong(inihand,section,item,default);
end;

function inireadreal(inihand:pinihead;section:string;item:string;default:real):real;
var find:boolean;
    cursection:pinisection;
    curitem:piniitem;
begin
section:=uppercase(section); item:=uppercase(item);
inireadreal:=default;
find:=false;
cursection:=inihand^.firstsection;
while cursection<>nil do
      with cursection^ do
           begin
           if pchartostring(sectionname)=section then
              begin
              curitem:=firstitem;
              while curitem<>nil do
                    with curitem^ do
                         begin
                         if pchartostring(itemname)=item then
                            begin
                            find:=true;
                            inireadreal:=rdata;
                            end;
                         curitem:=nextitem;
                         end;
              end;
           cursection:=nextsection;
           end;
if not find then iniwritereal(inihand,section,item,default);
end;

function inireadbool(inihand:pinihead;section:string;item:string;default:boolean):boolean;
var find:boolean;
    cursection:pinisection;
    curitem:piniitem;
begin
section:=uppercase(section); item:=uppercase(item);
inireadbool:=default;
find:=false;
cursection:=inihand^.firstsection;
while cursection<>nil do
      with cursection^ do
           begin
           if pchartostring(sectionname)=section then
              begin
              curitem:=firstitem;
              while curitem<>nil do
                    with curitem^ do
                         begin
                         if pchartostring(itemname)=item then
                            begin
                            find:=true;
                            inireadbool:=bdata;
                            end;
                         curitem:=nextitem;
                         end;
              end;
           cursection:=nextsection;
           end;
if not find then iniwritebool(inihand,section,item,default);
end;

procedure iniwritestring(inihand:pinihead;section:string;item:string;data:string);
var cursection,cs:pinisection;
    curitem,ci:piniitem;
    sectionptr:pinisection;
    itemptr:piniitem;
begin
section:=uppercase(section); item:=uppercase(item); data:=uppercase(data);
sectionptr:=nil; itemptr:=nil;

cursection:=inihand^.firstsection;
while cursection<>nil do
      with cursection^ do
           begin
           if pchartostring(sectionname)=section then
              begin
              sectionptr:=cursection;
              curitem:=firstitem;
              while curitem<>nil do
                    with curitem^ do
                         begin
                         if pchartostring(itemname)=item then
                            begin
                            itemptr:=curitem;
                            end;
                         ci:=curitem;
                         curitem:=nextitem;
                         end;
              end;
           cs:=cursection;
           cursection:=nextsection;
           end;
if itemptr<>nil then
   with itemptr^ do
        begin
        if kind=0 then killpchar(sdata);
        sdata:=stringtopchar(data);
        kind:=0;
        exit;
        end;
if sectionptr<>nil then
   begin
   new(curitem); if sectionptr^.firstitem=nil then
                    sectionptr^.firstitem:=curitem else ci^.nextitem:=curitem;
   with curitem^ do
        begin
        nextitem:=nil;
        itemname:=stringtopchar(item);
        sdata:=stringtopchar(data);
        kind:=0;
        end;
   exit;
   end;
new(cursection); if inihand^.firstsection=nil then
                    inihand^.firstsection:=cursection else cs^.nextsection:=cursection;
with cursection^ do
     begin
     nextsection:=nil;
     sectionname:=stringtopchar(section);
     new(curitem); firstitem:=curitem;
     with curitem^ do
          begin
          nextitem:=nil;
          itemname:=stringtopchar(item);
          sdata:=stringtopchar(data);
          kind:=0;
          end;
     end;
end;

procedure iniwritelong(inihand:pinihead;section:string;item:string;data:longint);
var cursection,cs:pinisection;
    curitem,ci:piniitem;
    sectionptr:pinisection;
    itemptr:piniitem;
begin
section:=uppercase(section); item:=uppercase(item);
sectionptr:=nil; itemptr:=nil;

cursection:=inihand^.firstsection;
while cursection<>nil do
      with cursection^ do
           begin
           if pchartostring(sectionname)=section then
              begin
              sectionptr:=cursection;
              curitem:=firstitem;
              while curitem<>nil do
                    with curitem^ do
                         begin
                         if pchartostring(itemname)=item then
                            begin
                            itemptr:=curitem;
                            end;
                         ci:=curitem;
                         curitem:=nextitem;
                         end;
              end;
           cs:=cursection;
           cursection:=nextsection;
           end;
if itemptr<>nil then
   with itemptr^ do
        begin
        if kind=0 then killpchar(sdata);
        ldata:=data;
        kind:=1;
        exit;
        end;
if sectionptr<>nil then
   begin
   new(curitem); if sectionptr^.firstitem=nil then
                    sectionptr^.firstitem:=curitem else ci^.nextitem:=curitem;
   with curitem^ do
        begin
        nextitem:=nil;
        itemname:=stringtopchar(item);
        ldata:=data;
        kind:=1;
        end;
   exit;
   end;
new(cursection); if inihand^.firstsection=nil then
                    inihand^.firstsection:=cursection else cs^.nextsection:=cursection;
with cursection^ do
     begin
     nextsection:=nil;
     sectionname:=stringtopchar(section);
     new(curitem); firstitem:=curitem;
     with curitem^ do
          begin
          nextitem:=nil;
          itemname:=stringtopchar(item);
          ldata:=data;
          kind:=1;
          end;
     end;
end;

procedure iniwritereal(inihand:pinihead;section:string;item:string;data:real);
var cursection,cs:pinisection;
    curitem,ci:piniitem;
    sectionptr:pinisection;
    itemptr:piniitem;
begin
section:=uppercase(section); item:=uppercase(item);
sectionptr:=nil; itemptr:=nil;

cursection:=inihand^.firstsection;
while cursection<>nil do
      with cursection^ do
           begin
           if pchartostring(sectionname)=section then
              begin
              sectionptr:=cursection;
              curitem:=firstitem;
              while curitem<>nil do
                    with curitem^ do
                         begin
                         if pchartostring(itemname)=item then
                            begin
                            itemptr:=curitem;
                            end;
                         ci:=curitem;
                         curitem:=nextitem;
                         end;
              end;
           cs:=cursection;
           cursection:=nextsection;
           end;
if itemptr<>nil then
   with itemptr^ do
        begin
        if kind=0 then killpchar(sdata);
        rdata:=data;
        kind:=2;
        exit;
        end;
if sectionptr<>nil then
   begin
   new(curitem); if sectionptr^.firstitem=nil then
                    sectionptr^.firstitem:=curitem else ci^.nextitem:=curitem;
   with curitem^ do
        begin
        nextitem:=nil;
        itemname:=stringtopchar(item);
        rdata:=data;
        kind:=2;
        end;
   exit;
   end;
new(cursection); if inihand^.firstsection=nil then
                    inihand^.firstsection:=cursection else cs^.nextsection:=cursection;
with cursection^ do
     begin
     nextsection:=nil;
     sectionname:=stringtopchar(section);
     new(curitem); firstitem:=curitem;
     with curitem^ do
          begin
          nextitem:=nil;
          itemname:=stringtopchar(item);
          rdata:=data;
          kind:=2;
          end;
     end;
end;

procedure iniwritebool(inihand:pinihead;section:string;item:string;data:boolean);
var cursection,cs:pinisection;
    curitem,ci:piniitem;
    sectionptr:pinisection;
    itemptr:piniitem;
begin
section:=uppercase(section); item:=uppercase(item);
sectionptr:=nil; itemptr:=nil;

cursection:=inihand^.firstsection;
while cursection<>nil do
      with cursection^ do
           begin
           if pchartostring(sectionname)=section then
              begin
              sectionptr:=cursection;
              curitem:=firstitem;
              while curitem<>nil do
                    with curitem^ do
                         begin
                         if pchartostring(itemname)=item then
                            begin
                            itemptr:=curitem;
                            end;
                         ci:=curitem;
                         curitem:=nextitem;
                         end;
              end;
           cs:=cursection;
           cursection:=nextsection;
           end;
if itemptr<>nil then
   with itemptr^ do
        begin
        if kind=0 then killpchar(sdata);
        bdata:=data;
        kind:=3;
        exit;
        end;
if sectionptr<>nil then
   begin
   new(curitem); if sectionptr^.firstitem=nil then
                    sectionptr^.firstitem:=curitem else ci^.nextitem:=curitem;
   with curitem^ do
        begin
        nextitem:=nil;
        itemname:=stringtopchar(item);
        bdata:=data;
        kind:=3;
        end;
   exit;
   end;
new(cursection); if inihand^.firstsection=nil then
                    inihand^.firstsection:=cursection else cs^.nextsection:=cursection;
with cursection^ do
     begin
     nextsection:=nil;
     sectionname:=stringtopchar(section);
     new(curitem); firstitem:=curitem;
     with curitem^ do
          begin
          nextitem:=nil;
          itemname:=stringtopchar(item);
          bdata:=data;
          kind:=3;
          end;
     end;
end;


procedure inidelsection(inihand:pinihead;section:string);
var cursection,cs:pinisection;
    curitem,ci:piniitem;
begin
section:=uppercase(section);
cursection:=inihand^.firstsection; cs:=nil;
while cursection<>nil do
      with cursection^ do
           begin
           if pchartostring(sectionname)=section then
              begin
              curitem:=firstitem;
              while curitem<>nil do
                    with curitem^ do
                         begin
                         ci:=curitem;
                         curitem:=nextitem;
                         if kind=0 then killpchar(sdata);
                         killpchar(itemname);
                         dispose(ci);
                         end;

              if cs=nil then
                 inihand^.firstsection:=cursection^.nextsection
                 else cs^.nextsection:=cursection^.nextsection;
              killpchar(sectionname);
              dispose(cursection);
              cursection:=cs;
              end;
           cs:=cursection;
           cursection:=nextsection;
           end;
end;

procedure inidelitem(inihand:pinihead;section:string;item:string);
var cursection:pinisection;
    curitem,ci:piniitem;
begin
section:=uppercase(section); item:=uppercase(item);
cursection:=inihand^.firstsection;
while cursection<>nil do
      with cursection^ do
           begin
           if pchartostring(sectionname)=section then
              begin
              curitem:=firstitem; ci:=nil;
              while curitem<>nil do
                    with curitem^ do
                         begin
                         if pchartostring(itemname)=item then
                            begin
                            if ci=nil then
                               firstitem:=curitem^.nextitem
                               else ci^.nextitem:=curitem^.nextitem;
                            if kind=0 then killpchar(sdata);
                            killpchar(itemname);
                            dispose(curitem);
                            curitem:=ci;
                            end;
                         ci:=curitem;
                         curitem:=nextitem;
                         end;
              end;
           cursection:=nextsection;
           end;
end;


function inifirstsection(inihand:pinihead):pinisection;
begin
inifirstsection:=inihand^.firstsection;
end;

function ininextsection(inisection:pinisection):pinisection;
begin
ininextsection:=inisection^.nextsection;
end;

function inisectionname(inisection:pinisection):string;
begin
inisectionname:=pchartostring(inisection^.sectionname);
end;

function inisectionptr(inihand:pinihead;section:string):pinisection;
var cursection:pinisection;
begin
inisectionptr:=nil;
section:=uppercase(section);
cursection:=inihand^.firstsection; inisectionptr:=nil;
while cursection<>nil do
      with cursection^ do
           begin
           if pchartostring(sectionname)=section then begin inisectionptr:=cursection; exit; end;
           cursection:=cursection^.nextsection;
           end;
end;


function inifirstitem(inisection:pinisection):piniitem;
begin
inifirstitem:=inisection^.firstitem;
end;

function ininextitem(iniitem:piniitem):piniitem;
begin
ininextitem:=iniitem^.nextitem;
end;

function iniitemname(iniitem:piniitem):string;
begin
iniitemname:=pchartostring(iniitem^.itemname);
end;

function iniitemdata(iniitem:piniitem):string;
begin
with iniitem^ do
     case kind of
          0:iniitemdata:=pchartostring(sdata);
          1:iniitemdata:=long2str(ldata,0);
          2:iniitemdata:=realtostr(rdata);
          3:iniitemdata:=boolstr[bdata];
          end; {case}
end;

function iniitemptrtype(iniitem:piniitem):byte;
begin
iniitemptrtype:=iniitem^.kind;
end;

end.