unit strs;
interface
function str2wrd(s:string; var i:word):boolean;
function getwordstr(s:string; k:integer):string;
function uppercase(s:string):string;
function stringof(ch:char; count:byte):string;
function str2int(s:string; var i:integer):boolean;
function long2str(l:longint;signs:byte):string;
function int2str(i:integer):string;
function str2long(s:string; var i:longint):boolean;
function str2real(s:string; var r:real):boolean;
function real2str(r:real;signs,decs:byte):string;
function realtostr(r:real):string;
function LeadingZero(w : Word) : String;
function wrd2hex(w: Word):string;
function long2hex(l: longint):string;
function sgn(l:longint):shortint;
function binary(l:longint):string;

function bcd2bin(w:word):word;
function bin2bcd(w:word):word;

function pbcd2bin(w:word):word;
function bin2pbcd(w:word):word;

function stringtopchar(s:string):pointer;
function pchartostring(p:pointer):string;
procedure killpchar(var p:pointer);

implementation

function sgn;
begin
if l<>0 then sgn:=l div abs(l) else sgn:=0;
end;

function binary(l:longint):string;
var s:string;
    i:byte;
begin
s:='';
for i:=0 to 31 do
    begin
    s:=char(l and 1+48)+s;
    l:=l shr 1;
    end;
binary:=s;
end;

function wrd2hex;
const
  hexChars: array [0..$F] of Char =
    '0123456789ABCDEF';
var s:string;
begin
s:=     (hexChars[Hi(w) shr 4]+
        hexChars[Hi(w) and $F]+
        hexChars[Lo(w) shr 4]+
        hexChars[Lo(w) and $F]);
wrd2hex:=s;
end;

function long2hex(l: longint):string;
const
  hexChars: array [0..$F] of Char =
    '0123456789ABCDEF';
var s:string;
begin
s:=     hexchars[(l shr 28) and $f]+
        hexchars[(l shr 24) and $f]+
        hexchars[(l shr 20) and $f]+
        hexchars[(l shr 16) and $f]+
        hexchars[(l shr 12) and $f]+
        hexchars[(l shr 08) and $f]+
        hexchars[(l shr 04) and $f]+
        hexchars[(l shr 00) and $f];
long2hex:=s;
end;

function LeadingZero;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  LeadingZero := s;
end;


function getwordstr;
var i:integer;
v,r:string;
begin
r:='';
v:=s;
for i:=1 to k do begin
while ((length(v)>0) and(v[1]=' ')) do delete(v,1,1);
if i<>k then while ((length(v)>0) and(v[1]<>' ')) do delete(v,1,1);
end;
i:=1;
while((i<=length(v)) and(v[i]<>' ')) do begin r:=r+v[i];
inc(i);
end;
getwordstr:=r;
end;

function long2str(l:longint;signs:byte):string;
var s:string;
begin
str(l:signs,s);
long2str:=s;
end;

function real2str(r:real;signs,decs:byte):string;
var s:string;
begin
str(r:signs:decs,s);
real2str:=s;
end;

function realtostr(r:real):string;
var s:string;
begin
str(r,s);
realtostr:=s;
end;

function int2str(i:integer):string;
var s:string;
begin
str(i:6,s);
int2str:=s;
end;

function str2int;
var code:integer;
begin
val(s,i,code);
str2int:=(code=0);
end;

function str2long;
var code:integer;
begin
val(s,i,code);
str2long:=(code=0);
end;

function str2real(s:string; var r:real):boolean;
var code:integer;
begin
val(s,r,code);
str2real:=(code=0);
end;

function str2wrd;
var code:integer;
begin
val(s,i,code);
str2wrd:=(code=0);
end;

function uppercase;
var i:byte;
begin
for i:=1 to Length(s) do s[i]:=UpCase(s[i]);
uppercase:=s;
end;

function stringof;
var s:string;
z:byte;
begin
s:='';
for z:=1 to count do s:=s+ch;
{if count>1 then stringof:=ch+stringof(ch,count-1) else stringof:=ch;}
stringof:=s;
end;

function bcd2bin(w:word):word; assembler;
asm
mov ax,w
aad
end;

function bin2bcd(w:word):word; assembler;
asm
mov ax,w
aam
end;

function pbcd2bin(w:word):word; assembler;
asm
mov ax,w
shl ax,4
shr al,4
aad
end;

function bin2pbcd(w:word):word; assembler;
asm
mov ax,w
aam
shl al,4
shr ax,4
end;

function stringtopchar(s:string):pointer;
var p:pointer;
begin
getmem(p,length(s)+1);
move(s[0],p^,length(s)+1);
stringtopchar:=p;
end;

function pchartostring(p:pointer):string;
begin
pchartostring:=string(p^);
end;

procedure killpchar(var p:pointer);
begin
if p=nil then exit;
freemem(p,byte(p^)+1);
p:=nil;
end;

end.